Description

Bring int SettingRegistry, that should be an inventory for the settings.

Related issues:

Related to foreman-tasks - Bug #32729: Dynflow doesn't reflect changes in Set... Closed

Related to Foreman - Bug #32953: Fix the creation of missing settings Closed

Related to Foreman - Bug #32963: Load only core setting values the first time... Closed

Related to Foreman - Refactor #33280: Mark Settings defined by DSL as special... Closed

Related to Foreman - Refactor #34570: SettingPresenter - pass kwarks in Ruby ... Closed

Related to Foreman - Bug #34573: Settings defined by DSL are not properly enc... Closed

Blocked by Foreman - Refactor #30860: Create SettingPresenter as a proxy for ... Closed

Associated revisions

Revision 8137b14c - 04/22/2021 03:12 PM - Ondřej Ezr

Fixes #30862 - introduce SettingRegistry (#8002)

SettingRegistry keeps all the setting information as set of SettingPresenters in memory.

This registry should be the public API for accessing setting values and keeps all the information about settings.

That will allow dropping all information except `name` and `value` from database.

The public interface should be:

`Foreman.settings[<name>] => value` with syntactic suggar `Setting[<name>]` proxying to this method.

We load values from database per request and repopulate the values, what is quite fast. This allows us dropping the cache for setting.

Key implementation features:

Initialize the registry manually at specific moment and note if the registry is

ready or not by `ready?` method.

Reload values by `Foreman.setting.load_values` before every request

Disables validations on Setting default values creation as those come from code and thus should be always valid, also this creation will be

dropped in the future

Revision 74da3011 - 04/23/2021 02:15 PM - Ondřej Ezr

Refs #30862 - do not validate new settings

While creating the settings, the definitions are not loaded yet, so the

validations depending on other setting values are failing. We should not

validate on create anyway.

This is fixing a forgotten validation on new setting from 8137b14c.
History

#1 - 09/16/2020 09:20 PM - Ondřej Ezr

- Blocked by Refactor #30860: Create SettingPresenter as a proxy for setting UI values added

#2 - 09/16/2020 09:22 PM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/8002 added

#3 - 04/22/2021 03:12 PM - The Foreman Bot

- Fixed in Releases 2.5.0 added

#4 - 04/22/2021 04:01 PM - Ondřej Ezr

- Status changed from Ready For Testing to Closed

Applied in changeset foreman|8137b14ca0bc12e9a96258b02588eaa042d5eff8.

#5 - 04/23/2021 10:30 AM - The Foreman Bot

- Pull request https://github.com/theforeman/foreman/pull/8464 added

#6 - 06/07/2021 08:51 AM - Ondřej Ezr

- Related to Bug #32729: Dynflow doesn't reflect changes in Setting added

#7 - 07/07/2021 02:07 PM - Ondřej Ezr

- Related to Bug #32953: Fix the creation of missing settings added

#8 - 07/08/2021 01:15 PM - Ondřej Ezr

- Related to Bug #32963: Load only core setting values the first time we load them added

#9 - 08/18/2021 09:46 AM - Ondřej Ezr

- Related to Refactor #33280: Mark Settings defined by DSL as special category in DB added

#10 - 03/08/2022 12:22 PM - Ondřej Ezr

- Related to Refactor #34570: SettingPresenter - pass kwarks in Ruby 3 compatible format added

#11 - 03/08/2022 12:25 PM - Ondřej Ezr

- Related to Bug #34573: Settings defined by DSL are not properly encrypted added
